#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <cstrike>

new g_CtBotId;
new g_TBotId;
new g_CollisionOffset;
new g_RenderModeOffset;
new g_RenderClrOffset;
new g_RenderColor[4] = {255, 255, 255, 0};
new Float:g_Location[3] = {10000.0, 10000.0, 10000.0};

#define K_RENDER_NORMAL         0
#define K_RENDER_TRANS_COLOR    1

new Handle:g_Cvar_Sptime = INVALID_HANDLE;
new Float:g_sptime = 0.0;

#define TEAM_T     2
#define TEAM_CT    3
#define VERSION    "1.2"

public Plugin:myinfo = {
    name = "EndRound Blocker",
    author = "graczu_-, otstrel.ru team",
    description = "Disable endround on DM",
    version = VERSION,
    url = "http://www.sourcemod.net/"
};

public OnPluginStart()
{
    g_RenderModeOffset = FindSendPropOffs("CCSPlayer", "m_nRenderMode");
    g_RenderClrOffset = FindSendPropOffs("CCSPlayer", "m_clrRender");
    g_CollisionOffset = FindSendPropOffs("CBaseEntity", "m_CollisionGroup");
    HookEvent("player_spawn", PlayerSpawn);

    /*
        KLUGE: If plugin sm_ggdm is loaded, than 
        we need to hide bots once again after 
        spawn protection will be disabled.
    */    
    g_Cvar_Sptime = FindConVar("sm_ggdm_sptime");
    if ( g_Cvar_Sptime != INVALID_HANDLE ) {
        g_sptime = GetConVarFloat(g_Cvar_Sptime);
        HookConVarChange(g_Cvar_Sptime, SettingsChanged);
    }
    
}

public SettingsChanged (Handle:convar, const String:oldValue[], const String:newValue[])
{
    if ( convar == g_Cvar_Sptime )
    {
        g_sptime = GetConVarFloat(g_Cvar_Sptime);
    }
}

public OnMapStart()
{
    CreateTimer(5.0, CreateBots);
}

public Action:CreateBots(Handle:timer) {
    g_CtBotId = CreateFakeClient(" ");
    g_TBotId = CreateFakeClient("  ");
    AssignClientToTeam(g_CtBotId, TEAM_CT);
    AssignClientToTeam(g_TBotId, TEAM_T);
}

AssignClientToTeam(client, team) {
    CS_SwitchTeam(client, team);
    CS_RespawnPlayer(client);
}

public Action:PlayerSpawn(Handle:event, const String:name[], bool:dontBroadcast)
{
    new client = GetClientOfUserId(GetEventInt(event, "userid"));
    /*
        KLUGE: If plugin sm_ggdm_spawns is loaded, than 
        we need to hide bots in 0.1 after spawn, because
        they can be teleported right after spawn by that
        plugin.
    */
    if ( client == g_CtBotId ) {
        CreateTimer(0.1, HideBot, client);
        if ( g_sptime ) {
            CreateTimer(0.1+g_sptime, HideBot, client);
        }        
    } else if ( client == g_TBotId ) {
        CreateTimer(0.1, HideBot, client);
        if ( g_sptime ) {
            CreateTimer(0.1+g_sptime, HideBot, client);
        }        
    }
}

public Action:HideBot(Handle:timer, any:client) {
    // no damage
    SetEntProp(client, Prop_Data, "m_takedamage", 0, 1);
    // no block
    SetEntData(client, g_CollisionOffset, 2, 4, true);
    // teleport
    TeleportEntity(client, g_Location, NULL_VECTOR, NULL_VECTOR); 
    // no move
    SetEntityMoveType(client, MOVETYPE_NONE);
    // no color
    UTIL_Render(client, g_RenderColor);
}

UTIL_Render(client, const color[4])
{
    new mode = (color[3] == 255) ? K_RENDER_NORMAL : K_RENDER_TRANS_COLOR;
    
    SetEntData(client, g_RenderModeOffset, mode, 1);
    SetEntDataArray(client, g_RenderClrOffset, color, 4, 1);
    ChangeEdictState(client);
}
